using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Imaging;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Reflection;
using System.Text.RegularExpressions;
using System.Collections;
using System.IO;
using PaintDotNet.Effects;
using PaintDotNet;


namespace TRsAlphaCutter
{
    public class EffectPluginConfigDialog : PaintDotNet.Effects.EffectConfigDialog
    {
        private bool saver = false;

        private Bitmap Bmp;
        private Bitmap LargeBmp;
        private Bitmap bg;

        private Rectangle MyBounds = new Rectangle();
        private Point PanBase = new Point();
        bool PanFlag = false;
        bool MoveFlag = false;
        private PointF premotion = new Point();
        private Point fixmotion = new Point();
        private Point[] Nodes = new Point[0];
        private float ZoomValue = 1;
        private Rectangle PVP = new Rectangle();
        private Rectangle NewBounds = new Rectangle();
        private int NodeSelect = -1;
        float tension = .05f;
        bool lasso = false;
        PointF lastPXY = new Point();
        double dirxy = 0;
        bool startmove = false;
        int lassoSpace = 0;
        int lassoSense = 0;
        int lassoDistance = 0;
        Color LineColor = Color.Red;
        Color HandleColor = Color.Cyan;
        int clockwise = 0;
        Point testpoint1 = new Point();
        Point testpoint2 = new Point();

        private Panel PreviewPanel;
        private HScrollBar Zoom;
        private CheckBox maskEnable;
        private CheckBox showOutline;
        private CheckBox invertMask;
        private Panel panel1;
        private Label ZoomLab;
        private CheckBox SmoothEdge;
        private Label ERLab;
        private HScrollBar EdgeRound;
        private Button rstMask;
        private Button CancelBttn;
        private Label AFSp;
        private Label AFSn;
        private Label AFD;
        private HScrollBar AutoFollowSpace;
        private HScrollBar AutoFollowSens;
        private HScrollBar AutoFollowDist;
        private CheckBox AutoEdgeFollow;
        private RadioButton lineColorY;
        private RadioButton lineColorG;
        private RadioButton lineColorR;
        private Label label2;
        private Panel panel2;
        private Button buttonOK;

        public EffectPluginConfigDialog()
        {
            InitializeComponent();
        }

        protected override void InitialInitToken()
        {
            theEffectToken = new EffectPluginConfigToken(false,5,30,20,15);
        }


        protected override void InitTokenFromDialog()
        {
            ((EffectPluginConfigToken)EffectToken).Save = saver;
            ((EffectPluginConfigToken)EffectToken).Roundness = (int)(tension * 100);
            ((EffectPluginConfigToken)EffectToken).Distance = lassoDistance;
            ((EffectPluginConfigToken)EffectToken).Sensitivity = lassoSense;
            ((EffectPluginConfigToken)EffectToken).Spacing = lassoSpace;
        }

        protected override void InitDialogFromToken(EffectConfigToken effectToken)
        {
            EffectPluginConfigToken token = (EffectPluginConfigToken)effectToken;
            EdgeRound.Value = token.Roundness;
            AutoFollowDist.Value = token.Distance;
            AutoFollowSens.Value = token.Sensitivity;
            AutoFollowSpace.Value = token.Spacing;
            saver = false;
        }

        private void InitializeComponent()
        {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(EffectPluginConfigDialog));
            this.buttonOK = new System.Windows.Forms.Button();
            this.PreviewPanel = new System.Windows.Forms.Panel();
            this.Zoom = new System.Windows.Forms.HScrollBar();
            this.maskEnable = new System.Windows.Forms.CheckBox();
            this.showOutline = new System.Windows.Forms.CheckBox();
            this.invertMask = new System.Windows.Forms.CheckBox();
            this.panel1 = new System.Windows.Forms.Panel();
            this.lineColorY = new System.Windows.Forms.RadioButton();
            this.lineColorG = new System.Windows.Forms.RadioButton();
            this.lineColorR = new System.Windows.Forms.RadioButton();
            this.CancelBttn = new System.Windows.Forms.Button();
            this.rstMask = new System.Windows.Forms.Button();
            this.SmoothEdge = new System.Windows.Forms.CheckBox();
            this.AFSp = new System.Windows.Forms.Label();
            this.AFSn = new System.Windows.Forms.Label();
            this.AFD = new System.Windows.Forms.Label();
            this.ERLab = new System.Windows.Forms.Label();
            this.ZoomLab = new System.Windows.Forms.Label();
            this.AutoFollowSpace = new System.Windows.Forms.HScrollBar();
            this.AutoFollowSens = new System.Windows.Forms.HScrollBar();
            this.AutoFollowDist = new System.Windows.Forms.HScrollBar();
            this.AutoEdgeFollow = new System.Windows.Forms.CheckBox();
            this.EdgeRound = new System.Windows.Forms.HScrollBar();
            this.label2 = new System.Windows.Forms.Label();
            this.panel2 = new System.Windows.Forms.Panel();
            this.panel1.SuspendLayout();
            this.panel2.SuspendLayout();
            this.SuspendLayout();
            // 
            // buttonOK
            // 
            this.buttonOK.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.buttonOK.Location = new System.Drawing.Point(493, 86);
            this.buttonOK.Name = "buttonOK";
            this.buttonOK.Size = new System.Drawing.Size(72, 22);
            this.buttonOK.TabIndex = 2;
            this.buttonOK.Text = "OK";
            this.buttonOK.UseVisualStyleBackColor = true;
            this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
            // 
            // PreviewPanel
            // 
            this.PreviewPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.PreviewPanel.BackColor = System.Drawing.Color.Black;
            this.PreviewPanel.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
            this.PreviewPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.PreviewPanel.Location = new System.Drawing.Point(12, 12);
            this.PreviewPanel.Name = "PreviewPanel";
            this.PreviewPanel.Size = new System.Drawing.Size(770, 205);
            this.PreviewPanel.TabIndex = 4;
            this.PreviewPanel.TabStop = true;
            this.PreviewPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.PreviewPanel_Paint);
            this.PreviewPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.PreviewPanel_MouseDown);
            this.PreviewPanel.MouseMove += new System.Windows.Forms.MouseEventHandler(this.PreviewPanel_MouseMove);
            this.PreviewPanel.MouseUp += new System.Windows.Forms.MouseEventHandler(this.PreviewPanel_MouseUp);
            // 
            // Zoom
            // 
            this.Zoom.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.Zoom.LargeChange = 1;
            this.Zoom.Location = new System.Drawing.Point(368, 98);
            this.Zoom.Maximum = 3;
            this.Zoom.Minimum = -3;
            this.Zoom.Name = "Zoom";
            this.Zoom.Size = new System.Drawing.Size(106, 10);
            this.Zoom.TabIndex = 8;
            this.Zoom.Scroll += new System.Windows.Forms.ScrollEventHandler(this.Zoom_Scroll);
            this.Zoom.ValueChanged += new System.EventHandler(this.Zoom_ValueChanged);
            // 
            // maskEnable
            // 
            this.maskEnable.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.maskEnable.AutoSize = true;
            this.maskEnable.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.maskEnable.ForeColor = System.Drawing.Color.Yellow;
            this.maskEnable.Location = new System.Drawing.Point(6, 20);
            this.maskEnable.Name = "maskEnable";
            this.maskEnable.Size = new System.Drawing.Size(88, 17);
            this.maskEnable.TabIndex = 9;
            this.maskEnable.Text = "Mask Enable";
            this.maskEnable.UseVisualStyleBackColor = true;
            this.maskEnable.CheckedChanged += new System.EventHandler(this.maskEnable_CheckedChanged);
            // 
            // showOutline
            // 
            this.showOutline.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.showOutline.AutoSize = true;
            this.showOutline.Checked = true;
            this.showOutline.CheckState = System.Windows.Forms.CheckState.Checked;
            this.showOutline.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.showOutline.ForeColor = System.Drawing.Color.Yellow;
            this.showOutline.Location = new System.Drawing.Point(6, 48);
            this.showOutline.Name = "showOutline";
            this.showOutline.Size = new System.Drawing.Size(89, 17);
            this.showOutline.TabIndex = 10;
            this.showOutline.Text = "Show Outline";
            this.showOutline.UseVisualStyleBackColor = true;
            this.showOutline.CheckedChanged += new System.EventHandler(this.maskEnable_CheckedChanged);
            // 
            // invertMask
            // 
            this.invertMask.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.invertMask.AutoSize = true;
            this.invertMask.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.invertMask.ForeColor = System.Drawing.Color.Yellow;
            this.invertMask.Location = new System.Drawing.Point(100, 20);
            this.invertMask.Name = "invertMask";
            this.invertMask.Size = new System.Drawing.Size(82, 17);
            this.invertMask.TabIndex = 10;
            this.invertMask.Text = "Invert Mask";
            this.invertMask.UseVisualStyleBackColor = true;
            this.invertMask.CheckedChanged += new System.EventHandler(this.maskEnable_CheckedChanged);
            // 
            // panel1
            // 
            this.panel1.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.panel1.BackColor = System.Drawing.SystemColors.ControlDarkDark;
            this.panel1.Controls.Add(this.lineColorY);
            this.panel1.Controls.Add(this.lineColorG);
            this.panel1.Controls.Add(this.lineColorR);
            this.panel1.Controls.Add(this.CancelBttn);
            this.panel1.Controls.Add(this.rstMask);
            this.panel1.Controls.Add(this.SmoothEdge);
            this.panel1.Controls.Add(this.AFSp);
            this.panel1.Controls.Add(this.AFSn);
            this.panel1.Controls.Add(this.AFD);
            this.panel1.Controls.Add(this.ERLab);
            this.panel1.Controls.Add(this.ZoomLab);
            this.panel1.Controls.Add(this.AutoFollowSpace);
            this.panel1.Controls.Add(this.AutoFollowSens);
            this.panel1.Controls.Add(this.AutoFollowDist);
            this.panel1.Controls.Add(this.AutoEdgeFollow);
            this.panel1.Controls.Add(this.invertMask);
            this.panel1.Controls.Add(this.EdgeRound);
            this.panel1.Controls.Add(this.Zoom);
            this.panel1.Controls.Add(this.showOutline);
            this.panel1.Controls.Add(this.maskEnable);
            this.panel1.Controls.Add(this.buttonOK);
            this.panel1.Location = new System.Drawing.Point(221, 223);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(571, 125);
            this.panel1.TabIndex = 11;
            this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
            // 
            // lineColorY
            // 
            this.lineColorY.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.lineColorY.AutoSize = true;
            this.lineColorY.Image = ((System.Drawing.Image)(resources.GetObject("lineColorY.Image")));
            this.lineColorY.Location = new System.Drawing.Point(451, 43);
            this.lineColorY.Name = "lineColorY";
            this.lineColorY.Size = new System.Drawing.Size(29, 15);
            this.lineColorY.TabIndex = 15;
            this.lineColorY.UseVisualStyleBackColor = true;
            this.lineColorY.CheckedChanged += new System.EventHandler(this.lineColorY_CheckedChanged);
            // 
            // lineColorG
            // 
            this.lineColorG.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.lineColorG.AutoSize = true;
            this.lineColorG.Image = ((System.Drawing.Image)(resources.GetObject("lineColorG.Image")));
            this.lineColorG.Location = new System.Drawing.Point(413, 43);
            this.lineColorG.Name = "lineColorG";
            this.lineColorG.Size = new System.Drawing.Size(29, 15);
            this.lineColorG.TabIndex = 15;
            this.lineColorG.UseVisualStyleBackColor = true;
            this.lineColorG.CheckedChanged += new System.EventHandler(this.lineColorG_CheckedChanged);
            // 
            // lineColorR
            // 
            this.lineColorR.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.lineColorR.AutoSize = true;
            this.lineColorR.Checked = true;
            this.lineColorR.Image = ((System.Drawing.Image)(resources.GetObject("lineColorR.Image")));
            this.lineColorR.Location = new System.Drawing.Point(375, 43);
            this.lineColorR.Name = "lineColorR";
            this.lineColorR.Size = new System.Drawing.Size(29, 15);
            this.lineColorR.TabIndex = 15;
            this.lineColorR.TabStop = true;
            this.lineColorR.UseVisualStyleBackColor = true;
            this.lineColorR.CheckedChanged += new System.EventHandler(this.lineColorR_CheckedChanged);
            // 
            // CancelBttn
            // 
            this.CancelBttn.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.CancelBttn.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.CancelBttn.Location = new System.Drawing.Point(493, 58);
            this.CancelBttn.Name = "CancelBttn";
            this.CancelBttn.Size = new System.Drawing.Size(72, 22);
            this.CancelBttn.TabIndex = 14;
            this.CancelBttn.Text = "Cancel";
            this.CancelBttn.UseVisualStyleBackColor = true;
            this.CancelBttn.Click += new System.EventHandler(this.CancelBttn_Click);
            // 
            // rstMask
            // 
            this.rstMask.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.rstMask.Location = new System.Drawing.Point(493, 16);
            this.rstMask.Name = "rstMask";
            this.rstMask.Size = new System.Drawing.Size(72, 21);
            this.rstMask.TabIndex = 13;
            this.rstMask.Text = "Reset Mask";
            this.rstMask.UseVisualStyleBackColor = true;
            this.rstMask.Click += new System.EventHandler(this.rstMask_Click);
            // 
            // SmoothEdge
            // 
            this.SmoothEdge.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.SmoothEdge.AutoSize = true;
            this.SmoothEdge.Checked = true;
            this.SmoothEdge.CheckState = System.Windows.Forms.CheckState.Checked;
            this.SmoothEdge.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.SmoothEdge.ForeColor = System.Drawing.Color.Yellow;
            this.SmoothEdge.Location = new System.Drawing.Point(100, 49);
            this.SmoothEdge.Name = "SmoothEdge";
            this.SmoothEdge.Size = new System.Drawing.Size(90, 17);
            this.SmoothEdge.TabIndex = 12;
            this.SmoothEdge.Text = "Smooth Edge";
            this.SmoothEdge.UseVisualStyleBackColor = true;
            this.SmoothEdge.CheckedChanged += new System.EventHandler(this.maskEnable_CheckedChanged);
            // 
            // AFSp
            // 
            this.AFSp.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.AFSp.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.AFSp.ForeColor = System.Drawing.Color.Yellow;
            this.AFSp.Location = new System.Drawing.Point(196, 81);
            this.AFSp.Name = "AFSp";
            this.AFSp.Size = new System.Drawing.Size(157, 17);
            this.AFSp.TabIndex = 11;
            this.AFSp.Text = "Auto Spacing 15";
            this.AFSp.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // AFSn
            // 
            this.AFSn.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.AFSn.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.AFSn.ForeColor = System.Drawing.Color.Yellow;
            this.AFSn.Location = new System.Drawing.Point(196, 49);
            this.AFSn.Name = "AFSn";
            this.AFSn.Size = new System.Drawing.Size(157, 17);
            this.AFSn.TabIndex = 11;
            this.AFSn.Text = "Auto Sensitivity 20";
            this.AFSn.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // AFD
            // 
            this.AFD.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.AFD.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.AFD.ForeColor = System.Drawing.Color.Yellow;
            this.AFD.Location = new System.Drawing.Point(196, 16);
            this.AFD.Name = "AFD";
            this.AFD.Size = new System.Drawing.Size(157, 17);
            this.AFD.TabIndex = 11;
            this.AFD.Text = "Auto Range 30";
            this.AFD.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            this.AFD.Click += new System.EventHandler(this.AFD_Click);
            // 
            // ERLab
            // 
            this.ERLab.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.ERLab.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ERLab.ForeColor = System.Drawing.Color.Yellow;
            this.ERLab.Location = new System.Drawing.Point(18, 76);
            this.ERLab.Name = "ERLab";
            this.ERLab.Size = new System.Drawing.Size(129, 17);
            this.ERLab.TabIndex = 11;
            this.ERLab.Text = "Edge Roundness 0.05";
            this.ERLab.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // ZoomLab
            // 
            this.ZoomLab.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.ZoomLab.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ZoomLab.ForeColor = System.Drawing.Color.Yellow;
            this.ZoomLab.Location = new System.Drawing.Point(368, 78);
            this.ZoomLab.Name = "ZoomLab";
            this.ZoomLab.Size = new System.Drawing.Size(106, 15);
            this.ZoomLab.TabIndex = 11;
            this.ZoomLab.Text = "Zoom 1X";
            this.ZoomLab.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // AutoFollowSpace
            // 
            this.AutoFollowSpace.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.AutoFollowSpace.LargeChange = 1;
            this.AutoFollowSpace.Location = new System.Drawing.Point(196, 98);
            this.AutoFollowSpace.Minimum = 5;
            this.AutoFollowSpace.Name = "AutoFollowSpace";
            this.AutoFollowSpace.Size = new System.Drawing.Size(157, 10);
            this.AutoFollowSpace.TabIndex = 8;
            this.AutoFollowSpace.Value = 15;
            this.AutoFollowSpace.Scroll += new System.Windows.Forms.ScrollEventHandler(this.AutoFollowSpace_Scroll);
            this.AutoFollowSpace.ValueChanged += new System.EventHandler(this.AutoFollowSpace_ValueChanged);
            // 
            // AutoFollowSens
            // 
            this.AutoFollowSens.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.AutoFollowSens.LargeChange = 1;
            this.AutoFollowSens.Location = new System.Drawing.Point(196, 66);
            this.AutoFollowSens.Maximum = 128;
            this.AutoFollowSens.Minimum = 5;
            this.AutoFollowSens.Name = "AutoFollowSens";
            this.AutoFollowSens.Size = new System.Drawing.Size(157, 10);
            this.AutoFollowSens.TabIndex = 8;
            this.AutoFollowSens.Value = 20;
            this.AutoFollowSens.Scroll += new System.Windows.Forms.ScrollEventHandler(this.AutoFollowSens_Scroll);
            this.AutoFollowSens.ValueChanged += new System.EventHandler(this.AutoFollowSens_ValueChanged);
            // 
            // AutoFollowDist
            // 
            this.AutoFollowDist.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.AutoFollowDist.LargeChange = 1;
            this.AutoFollowDist.Location = new System.Drawing.Point(196, 33);
            this.AutoFollowDist.Minimum = 1;
            this.AutoFollowDist.Name = "AutoFollowDist";
            this.AutoFollowDist.Size = new System.Drawing.Size(157, 10);
            this.AutoFollowDist.TabIndex = 8;
            this.AutoFollowDist.Value = 30;
            this.AutoFollowDist.Scroll += new System.Windows.Forms.ScrollEventHandler(this.AutoFollowDist_Scroll);
            this.AutoFollowDist.ValueChanged += new System.EventHandler(this.AutoFollowDist_ValueChanged);
            // 
            // AutoEdgeFollow
            // 
            this.AutoEdgeFollow.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.AutoEdgeFollow.AutoSize = true;
            this.AutoEdgeFollow.Checked = true;
            this.AutoEdgeFollow.CheckState = System.Windows.Forms.CheckState.Checked;
            this.AutoEdgeFollow.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.AutoEdgeFollow.ForeColor = System.Drawing.Color.Yellow;
            this.AutoEdgeFollow.Location = new System.Drawing.Point(371, 21);
            this.AutoEdgeFollow.Name = "AutoEdgeFollow";
            this.AutoEdgeFollow.Size = new System.Drawing.Size(109, 17);
            this.AutoEdgeFollow.TabIndex = 10;
            this.AutoEdgeFollow.Text = "Auto Edge Follow";
            this.AutoEdgeFollow.UseVisualStyleBackColor = true;
            this.AutoEdgeFollow.CheckedChanged += new System.EventHandler(this.maskEnable_CheckedChanged);
            // 
            // EdgeRound
            // 
            this.EdgeRound.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.EdgeRound.LargeChange = 1;
            this.EdgeRound.Location = new System.Drawing.Point(21, 98);
            this.EdgeRound.Maximum = 25;
            this.EdgeRound.Name = "EdgeRound";
            this.EdgeRound.Size = new System.Drawing.Size(129, 10);
            this.EdgeRound.TabIndex = 8;
            this.EdgeRound.Value = 5;
            this.EdgeRound.Scroll += new System.Windows.Forms.ScrollEventHandler(this.EdgeRound_Scroll);
            this.EdgeRound.ValueChanged += new System.EventHandler(this.EdgeRound_ValueChanged);
            // 
            // label2
            // 
            this.label2.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.label2.ForeColor = System.Drawing.Color.Yellow;
            this.label2.Location = new System.Drawing.Point(3, 0);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(202, 123);
            this.label2.TabIndex = 0;
            this.label2.Text = resources.GetString("label2.Text");
            // 
            // panel2
            // 
            this.panel2.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.panel2.BackColor = System.Drawing.Color.Maroon;
            this.panel2.Controls.Add(this.label2);
            this.panel2.Location = new System.Drawing.Point(2, 223);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(213, 123);
            this.panel2.TabIndex = 12;
            // 
            // EffectPluginConfigDialog
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
            this.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
            this.ClientSize = new System.Drawing.Size(794, 351);
            this.Controls.Add(this.panel2);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.PreviewPanel);
            this.DoubleBuffered = true;
            this.KeyPreview = true;
            this.Location = new System.Drawing.Point(0, 0);
            this.Name = "EffectPluginConfigDialog";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "TR\'s Alpha Cutter";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.Load += new System.EventHandler(this.EffectPluginConfigDialog_Load);
            this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.EffectPluginConfigDialog_KeyDown);
            this.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.PreviewPanel_MouseWheel);
            this.Controls.SetChildIndex(this.PreviewPanel, 0);
            this.Controls.SetChildIndex(this.panel1, 0);
            this.Controls.SetChildIndex(this.panel2, 0);
            this.panel1.ResumeLayout(false);
            this.panel1.PerformLayout();
            this.panel2.ResumeLayout(false);
            this.ResumeLayout(false);

        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            buttonOK.Enabled = false;
            maskEnable.Checked = true;
            saver = true;
            Bmp.Save(System.IO.Path.GetTempPath() + @"TRsAC.bmp");
            FinishTokenUpdate();
            DialogResult = DialogResult.OK;
            this.Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void reload()
        {
            MyBounds = EffectSourceSurface.Bounds;
            PVP = PreviewPanel.Bounds;
            Bitmap bm = new RenderArgs(EffectSourceSurface).Bitmap;
            Bmp = new Bitmap(bm.Width, bm.Height);
            LargeBmp = new Bitmap(bm.Width, bm.Height);
            Graphics g = Graphics.FromImage(LargeBmp);
            g.DrawImage(bm, 0, 0);
            bm.Dispose();
            g.Dispose();


            //checkerboard
            bg = new Bitmap(MyBounds.Width, MyBounds.Height);
            Surface tmp = new Surface(EffectSourceSurface.Size);
            tmp.ClearWithCheckerboardPattern();
            Bitmap b = new RenderArgs(tmp).Bitmap;
            Graphics g1 = Graphics.FromImage(bg);
            g1.DrawImage(b, 0, 0);
            g1.Dispose();
            tmp.Dispose();
            GC.Collect();
        }

        private void EffectPluginConfigDialog_Load(object sender, EventArgs e)
        {
            reload();
            ResizePVP();
            PanBounds(0, 0);
            this.MinimumSize = this.Size;
            Version version = Assembly.GetExecutingAssembly().GetName().Version;
            this.Text = EffectPlugin.StaticName + " ver. " + version.Major + "." + version.Minor + "." + version.Build;
            this.lassoDistance = AutoFollowDist.Value;
            this.lassoSense = AutoFollowSens.Value;
            this.lassoSpace = AutoFollowSpace.Value;
        }


        private unsafe void DrawGraphics()
        {
            Bitmap basebmp = new Bitmap(MyBounds.Width, MyBounds.Height);
            Graphics b = Graphics.FromImage(basebmp);
            b.CompositingMode = CompositingMode.SourceOver;
            b.SmoothingMode = SmoothingMode.AntiAlias;
            b.InterpolationMode = InterpolationMode.NearestNeighbor;


            //add Checker layer
            b.DrawImage(bg, 0, 0);

            //add overlay

            if (!maskEnable.Checked | Nodes.Length < 3) { b.DrawImage(LargeBmp, 0, 0); }


            if (Nodes.Length >= 3 & maskEnable.Checked)
            {
                Bmp = new Bitmap(MyBounds.Width, MyBounds.Height);
                Graphics gd = Graphics.FromImage(Bmp);
                gd.CompositingMode = CompositingMode.SourceOver;
                if (SmoothEdge.Checked)
                {
                    gd.SmoothingMode = SmoothingMode.AntiAlias;
                }
                else
                {
                    gd.SmoothingMode = SmoothingMode.None;
                }

                gd.FillClosedCurve(Brushes.White, Nodes, FillMode.Alternate, tension);

                gd.Dispose();

                BitmapData bmdTo = Bmp.LockBits(new Rectangle(0, 0, MyBounds.Width, MyBounds.Height),
                    System.Drawing.Imaging.ImageLockMode.ReadWrite, Bmp.PixelFormat);

                BitmapData bmdFrom = LargeBmp.LockBits(new Rectangle(0, 0, MyBounds.Width, MyBounds.Height), 
                    System.Drawing.Imaging.ImageLockMode.ReadWrite, LargeBmp.PixelFormat);

                byte* rowsfrom = (byte*)bmdFrom.Scan0;
                byte* rowsto = (byte*)bmdTo.Scan0;
                //byte mask = 255;
                for (int y = 0; y < MyBounds.Height; y++)
                {
                    for (int x = 0; x < MyBounds.Width; x++)
                    {
                        for (int i = 0; i < 3; i++)
                        {
                            rowsto[y * bmdTo.Stride + 4 * x + i] = rowsfrom[y * bmdFrom.Stride + 4 * x + i];
                        }
                        
                        byte alphachk = rowsfrom[y * bmdFrom.Stride + 4 * x + 3];
                        byte alphachk2 = rowsto[y * bmdTo.Stride + 4 * x + 3];
                        if (invertMask.Checked)alphachk2 = (byte)(255 - alphachk2);
                        if (alphachk < alphachk2) alphachk2=alphachk;
                        rowsto[y * bmdTo.Stride + 4 * x + 3] = alphachk2;
                        
                        
                    }
                }
                Bmp.UnlockBits(bmdTo);
                LargeBmp.UnlockBits(bmdFrom);
                b.DrawImage(Bmp, 0, 0);

            }
            // draw outline & nodes
            Pen pen = new Pen(LineColor);
            if (Nodes.Length >= 3 & !maskEnable.Checked & showOutline.Checked) { b.DrawClosedCurve(pen, Nodes, tension ,FillMode.Alternate); }

            for (int i = 0; i < Nodes.Length; i++)
            {
                if (!maskEnable.Checked)
                {
                    pen =new Pen(LineColor);
                    if (i == NodeSelect){
                        pen = new Pen(HandleColor);
                    }

                    b.DrawEllipse(pen, new Rectangle(Nodes[i].X - 5
                        , Nodes[i].Y - 5, 10, 10));
                }
            }

            if (lasso) b.DrawLine(Pens.White, testpoint1, testpoint2);

            pen.Dispose();

            //draw on screen
            Graphics g = PreviewPanel.CreateGraphics();
            g.SmoothingMode = SmoothingMode.None;
            g.InterpolationMode = InterpolationMode.NearestNeighbor;
            g.CompositingMode = CompositingMode.SourceCopy;

            //mask black
            g.SetClip(PVP, CombineMode.Exclude);
            g.Clear(Color.Black);
            g.ResetClip();

            g.DrawImage(basebmp, PVP, PanBase.X, PanBase.Y, PVP.Width / ZoomValue,
                PVP.Height / ZoomValue, GraphicsUnit.Pixel);


            g.Dispose();
            b.Dispose();
            basebmp.Dispose();

            GC.Collect();
        }

        private void PreviewPanel_Paint(object sender, PaintEventArgs e)
        {
            DrawGraphics();
        }



        protected override void WndProc(ref Message message)
        {
            const int WM_SYSCOMMAND = 0x0112;
            const int SC_MOVE = 0xF010;

            switch (message.Msg)
            {
                case WM_SYSCOMMAND:
                    int command = message.WParam.ToInt32() & 0xfff0;
                    if (command == SC_MOVE)
                        return;
                    break;
            }

            base.WndProc(ref message);
        }

        private void PreviewPanel_MouseDown(object sender, MouseEventArgs e)
        {
            PointF ee = new PointF(e.X - PVP.X, e.Y - PVP.Y);

            ee.X /= ZoomValue;
            ee.Y /= ZoomValue;

            premotion = ee;
            fixmotion.X =(int)( ee.X + PanBase.X);
            fixmotion.Y = (int)(ee.Y + PanBase.Y);

            if (e.Button == MouseButtons.Right)
            {
                PanFlag = true;
            }
            else if (e.Button == MouseButtons.Left && !maskEnable.Checked)
            {
                if (CheckNode())
                {//move node
                    MoveFlag = true;
                }
                else if (NodeSelect >= 0)
                {

                    Nodes = MyUtils.InsertP(Nodes, NodeSelect, fixmotion);
                    NodeSelect = -1;
                }
                else
                {//add node
                    Array.Resize(ref Nodes, Nodes.Length + 1);
                    Nodes[Nodes.Length - 1] = fixmotion;
                    lastPXY = fixmotion;
                    dirxy = 0;
                    startmove = true;
                    clockwise = 0;
                    if (AutoEdgeFollow.Checked) lasso = true;
                    
                }
            }

        }
        private bool CheckNode()
        {

            if (Nodes.Length == 0) return false;
            bool results = false;
            for (int i = 0; i < Nodes.Length; i++)
            {
                if (MyUtils.PythagP(Nodes[i], fixmotion) <= 5)
                {
                    results = true;
                    NodeSelect = i;
                }

            }
            return results;
        }
        private void PreviewPanel_MouseMove(object sender, MouseEventArgs e)
        {
            PointF ee = new Point(e.X - PVP.X, e.Y - PVP.Y);

            ee.X /= ZoomValue;
            ee.Y /= ZoomValue;


            if (MoveFlag)
            {

                Nodes[NodeSelect].X =(int)( ee.X + PanBase.X);
                Nodes[NodeSelect].Y = (int)(ee.Y + PanBase.Y);
                DrawGraphics();
            }

            if (PanFlag)
            {

                PointF motion = new PointF(ee.X, ee.Y);
                int movex = (int)(premotion.X - motion.X + PanBase.X);
                premotion.X = motion.X;
                int movey = (int)(premotion.Y - motion.Y + PanBase.Y);
                premotion.Y = motion.Y;

                PanBounds(movex, movey);
            }

            if (lasso)
            {
                PointF xy = new PointF( ee.X + PanBase.X,ee.Y + PanBase.Y);
                Point firstXY=Nodes[Nodes.Length-1];

                ColorBgra CP = EffectSourceSurface.GetBilinearSample(xy.X, xy.Y);
                if (startmove)
                {
                    dirxy = Math.Atan2(xy.Y - lastPXY.Y, xy.X - lastPXY.X);
                }
                else
                {
                    dirxy = dirxy * 0.9f + Math.Atan2(xy.Y - lastPXY.Y, xy.X - lastPXY.X) * 0.1f;
                }

                               
                int bw2;
                PointF PXY = xy;

                testpoint1 = new Point((int)((float)xy.X + Math.Cos(dirxy + 1.57f) * lassoDistance),
                    (int)((float)xy.Y + Math.Sin(dirxy + 1.57f) * lassoDistance));
                testpoint2 = new Point((int)((float)xy.X + Math.Cos(dirxy - 1.57f) * lassoDistance),
                    (int)((float)xy.Y + Math.Sin(dirxy - 1.57f) * lassoDistance));

                for (float j = 1; j < lassoDistance; j++)
                {
                    //check left
                    int sx;
                    int sy;
                    ColorBgra CP2;

                    if (clockwise > -1)
                    {
                        sx = (int)((float)xy.X + Math.Cos(dirxy - 1.57f) * j);
                        sy = (int)((float)xy.Y + Math.Sin(dirxy - 1.57f) * j);
                        CP2 = EffectSourceSurface.GetBilinearSampleClamped(sx, sy);
                        bw2 = (int)MyUtils.PythagTriple(CP, CP2);

                        if (bw2 > lassoSense)
                        {
                            clockwise = 1;
                            PXY.X = sx;
                            PXY.Y = sy;
                            break;
                        }
                    }
                    if (clockwise < 1)
                    {
                        sx = (int)((float)xy.X + Math.Cos(dirxy + 1.57f) * j);
                        sy = (int)((float)xy.Y + Math.Sin(dirxy + 1.57f) * j);
                        CP2 = EffectSourceSurface.GetBilinearSampleClamped(sx, sy);
                        bw2 = (int)MyUtils.PythagTriple(CP, CP2);
                        if (bw2 > lassoSense)
                        {
                            clockwise = -1;
                            PXY.X = sx;
                            PXY.Y = sy;
                            break;
                        }
                    }

                }

                double dist = MyUtils.PythagP(PXY, firstXY);
                if (lasso && (dist>=lassoSpace))
                {
                    Array.Resize(ref Nodes, Nodes.Length + 1);
                    Nodes[Nodes.Length - 1] =new Point((int)PXY.X,(int)PXY.Y);
                    startmove = false;
                    lastPXY = xy; 

                }
            }


            DrawGraphics();
        }
        private void PreviewPanel_MouseUp(object sender, MouseEventArgs e)
        {
            MoveFlag = false;
            PanFlag = false;
            clockwise = 0;
            lasso = false;
            DrawGraphics();

        }


        private void ResizePVP()
        {
            NewBounds = new Rectangle(0, 0,(int)((float) MyBounds.Width * ZoomValue),(int)((float) MyBounds.Height * ZoomValue));
            PVP = PreviewPanel.ClientRectangle;

            if (PVP.Width >= NewBounds.Width)
            {
                PVP.Width = NewBounds.Width;
                PVP.X = (PreviewPanel.ClientRectangle.Width - PVP.Width) / 2;

            }

            if (PVP.Height >= NewBounds.Height)
            {
                PVP.Height = NewBounds.Height;
                PVP.Y = (PreviewPanel.ClientRectangle.Height - PVP.Height) / 2;
            }


        }

        private void PanBounds(int movex, int movey)
        {
            ResizePVP();
            Rectangle PVMax = PreviewPanel.ClientRectangle;
            if (NewBounds.Width > PVMax.Width)
            {
                PanBase.X = MyUtils.clamp(movex, 0, MyBounds.Width - (int)((float)PVMax.Width / ZoomValue));
            }
            else
            {
                PanBase.X = 0;
            }

            if (NewBounds.Height > PVMax.Height)
            {
                PanBase.Y = MyUtils.clamp(movey, 0, MyBounds.Height - (int)((float)PVMax.Height / ZoomValue));
            }
            else
            {
                PanBase.Y=0;
            }

        }

        private void Zoom_Scroll(object sender, ScrollEventArgs e)
        {
            if (e.Type == ScrollEventType.EndScroll)
            {
                
                PanBounds(PanBase.X, PanBase.Y);
                DrawGraphics();
            }
        }

        private void maskEnable_CheckedChanged(object sender, EventArgs e)
        {
            DrawGraphics();
        }

        private void EffectPluginConfigDialog_KeyDown(object sender, KeyEventArgs e)
        {

            if (NodeSelect > -1 && e.KeyCode == Keys.Delete)
            {
                Nodes = MyUtils.RemoveP(Nodes, NodeSelect);
                NodeSelect = -1;
                DrawGraphics();
            }
            else if (NodeSelect > -1 && e.KeyCode == Keys.Escape)
            {
                NodeSelect = -1;
                DrawGraphics();
            }else if(e.KeyCode == Keys.Back)
            {
                if (NodeSelect == -1 && Nodes.Length > 0)
                {
                    NodeSelect = -1;
                    Array.Resize(ref Nodes, Nodes.Length - 1);
                    DrawGraphics();
                }
            }
        }

        private void PreviewPanel_MouseWheel(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            Zoom.Value = MyUtils.clamp(e.Delta/120 + Zoom.Value, -3, 3);
            PanBounds(PanBase.X, PanBase.Y);
            DrawGraphics();
        }

        private void EdgeRound_ValueChanged(object sender, EventArgs e)
        {
            ERLab.Text = "Edge Roundness " + Convert.ToString((float)EdgeRound.Value / 100f);
        }

        private void Zoom_ValueChanged(object sender, EventArgs e)
        {
            ZoomValue =(float) Math.Pow(2, Zoom.Value);
            ZoomLab.Text = "Zoom "+ ZoomValue.ToString() + "X";
        }

        private void EdgeRound_Scroll(object sender, ScrollEventArgs e)
        {
            if (e.Type == ScrollEventType.EndScroll)
            {
                tension = (float)EdgeRound.Value / 100.0f;
                DrawGraphics();
            }
        }

        private void rstMask_Click(object sender, EventArgs e)
        {
            Array.Resize(ref Nodes, 0);
            NodeSelect = -1;
            DrawGraphics();
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void AutoFollowDist_Scroll(object sender, ScrollEventArgs e)
        {
            if (e.Type == ScrollEventType.EndScroll)
            {

               lassoDistance=AutoFollowDist.Value;
            }
        }
        private void AutoFollowDist_ValueChanged(object sender, EventArgs e)
        {
                AFD.Text = "Auto Range " + AutoFollowDist.Value.ToString();
        }

        private void AutoFollowSens_Scroll(object sender, ScrollEventArgs e)
        {
            if (e.Type == ScrollEventType.EndScroll)
            {

                lassoSense = AutoFollowSens.Value;
            }
        }
        private void AutoFollowSens_ValueChanged(object sender, EventArgs e)
        {
                AFSn.Text = "Auto Sensitivity " + AutoFollowSens.Value.ToString();
        }

        private void AutoFollowSpace_Scroll(object sender, ScrollEventArgs e)
        {
            if (e.Type == ScrollEventType.EndScroll)
            {

                lassoSpace = AutoFollowSpace.Value;
            }
        }

        private void AutoFollowSpace_ValueChanged(object sender, EventArgs e)
        {
                AFSp.Text = "Auto Spacing " + AutoFollowSpace.Value.ToString();
        }

        private void CancelBttn_Click(object sender, EventArgs e)
        {
            saver = false;
            FinishTokenUpdate();
            DialogResult = DialogResult.Cancel;
            this.Close();
        }

        private void lineColorR_CheckedChanged(object sender, EventArgs e)
        {
            LineColor = Color.Red;
            HandleColor = Color.Cyan;
            DrawGraphics();
        }

        private void lineColorG_CheckedChanged(object sender, EventArgs e)
        {
            LineColor = Color.Green;
            HandleColor = Color.Magenta;
            DrawGraphics();
        }

        private void lineColorY_CheckedChanged(object sender, EventArgs e)
        {
            LineColor = Color.Yellow;
            HandleColor = Color.Blue;
            DrawGraphics();
        }

        private void AFD_Click(object sender, EventArgs e)
        {

        }

    }
}