﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using PaintDotNet;

namespace TRsAlphaCutter
{
    class MyUtils
    {
        public static int clamp(int p, int l, int h)
        {
            p = (p < l) ? l : (p > h) ? h : p;

            return p;
        }
        public static int clampD(double p, int l, int h)
        {
            p = (p < l) ? l : (p > h) ? h : p;

            return (int)p;
        }
        public static Point clampP(Point p, Rectangle r)
        {
            p.X = (p.X < r.Left) ? r.Left : (p.X > r.Right) ? r.Right : p.X;
            p.Y = (p.Y < r.Top) ? r.Top : (p.Y > r.Bottom) ? r.Bottom : p.Y;
            return p;
        }
        public static Rectangle clampR(Rectangle p, Rectangle r)
        {
            int left = (p.X < r.Left) ? r.Left : (p.X > r.Right) ? r.Right : p.X;
            int top = (p.Y < r.Top) ? r.Top : (p.Y > r.Bottom) ? r.Bottom : p.Y;
            int right = (p.Right < r.Left) ? r.Left : (p.Right > r.Right) ? r.Right : p.Right;
            int bottom = (p.Bottom < r.Top) ? r.Top : (p.Bottom > r.Bottom) ? r.Bottom : p.Bottom;
            return new Rectangle(left, top, right - left, bottom - top);
        }
        public static double Pythag(double p1, double p2)
        {
            return Math.Sqrt(p1 * p1 + p2 * p2);
        }

        public static double PythagP(PointF p1, PointF p2)
        {
            return Math.Sqrt((p2.X - p1.X) * (p2.X - p1.X) + (p2.Y - p1.Y) * (p2.Y - p1.Y));
        }
        public static double PythagTriple(ColorBgra CP ,ColorBgra CP2 )
        {
            return Math.Sqrt((CP.G -CP2.G) * (CP.G -CP2.G) +(CP.B -CP2.B) * (CP.B -CP2.B) +
                (CP.R -CP2.R) * (CP.R -CP2.R));
        }

        public static Point Centroid(Point[] source)
        {
            Point tmp = new Point();
            if (source.Length == 0) return tmp;
            foreach (Point i in source)
            {
                tmp.X += i.X;
                tmp.Y += i.Y;
            }
            tmp.X /= source.Length;
            tmp.Y /= source.Length;
            return tmp;
        }
        public static Point[] RemoveP(Point[] source, int index)
        {
            Point[] dest = new Point[source.Length - 1];
            if ((index > -1) && (index < source.Length))
            {
                Array.Copy(source, 0, dest, 0, index);
                Array.Copy(source, index + 1, dest, index, source.Length - index - 1);
                return dest;
            }
            else
            {
                return source;
            }
        }
        public static Point[] InsertP(Point[] source, int index, Point p)
        {
            Point[] dest = new Point[source.Length + 1];
            if ((index > -1) && (index < source.Length - 1))
            {
                Array.Copy(source, 0, dest, 1, source.Length);
                Array.Copy(source, 0, dest, 0, index + 1);
                dest[index + 1] = p;
                return dest;
            }
            else
            {
                return source;
            }

        }
    }

}
